SDL_shape.h File Reference
`#include "SDL_stdinc.h"`
`#include "SDL_pixels.h"`
`#include "SDL_rect.h"`
`#include "SDL_surface.h"`
`#include "SDL_video.h"`
`#include "begin_code.h"`
`#include "close_code.h"`
Include dependency graph for SDL_shape.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Data Structures

union | SDL_WindowShapeParams
| A union containing parameters for shaped windows. More...
struct | SDL_WindowShapeMode
| A struct that tags the SDL_WindowShapeParams union with an enum describing the type of its contents. More...

## Macros

#define | SDL_NONSHAPEABLE_WINDOW -1
#define | SDL_INVALID_SHAPE_ARGUMENT -2
#define | SDL_WINDOW_LACKS_SHAPE -3
#define | SDL_SHAPEMODEALPHA(mode)

## Enumerations

enum | WindowShapeMode { ShapeModeDefault , ShapeModeBinarizeAlpha , ShapeModeReverseBinarizeAlpha , ShapeModeColorKey }
| An enum denoting the specific type of contents present in an SDL_WindowShapeParams union. More...

## Functions

SDL_Window * | SDL_CreateShapedWindow (const char *title, unsigned int x, unsigned int y, unsigned int w, unsigned int h, Uint32 flags)
SDL_bool | SDL_IsShapedWindow (const SDL_Window *window)
int | SDL_SetWindowShape (SDL_Window *window, SDL_Surface *shape, SDL_WindowShapeMode *shape_mode)
int | SDL_GetShapedWindowMode (SDL_Window *window, SDL_WindowShapeMode *shape_mode)

## Detailed Description

Header file for the shaped window API.

Definition in file SDL_shape.h.

## Macro Definition Documentation

## SDL_INVALID_SHAPE_ARGUMENT

#define SDL_INVALID_SHAPE_ARGUMENT -2

Definition at line 43 of file SDL_shape.h.

## SDL_NONSHAPEABLE_WINDOW

#define SDL_NONSHAPEABLE_WINDOW -1

Definition at line 42 of file SDL_shape.h.

## SDL_SHAPEMODEALPHA

#define SDL_SHAPEMODEALPHA | ( |  | mode | ) |

Value:
(mode == ShapeModeDefault || mode == ShapeModeBinarizeAlpha || mode == ShapeModeReverseBinarizeAlpha)
ShapeModeBinarizeAlpha
@ ShapeModeBinarizeAlpha
A binarized alpha cutoff with a given integer value.
Definition SDL_shape.h:89
ShapeModeDefault
@ ShapeModeDefault
The default mode, a binarized alpha cutoff of 1.
Definition SDL_shape.h:87
ShapeModeReverseBinarizeAlpha
@ ShapeModeReverseBinarizeAlpha
A binarized alpha cutoff with a given integer value, but with the opposite comparison.
Definition SDL_shape.h:91

Definition at line 96 of file SDL_shape.h.

## SDL_WINDOW_LACKS_SHAPE

#define SDL_WINDOW_LACKS_SHAPE -3

Definition at line 44 of file SDL_shape.h.

## Enumeration Type Documentation

## WindowShapeMode

enum WindowShapeMode

An enum denoting the specific type of contents present in an SDL_WindowShapeParams union.

Enumerator
ShapeModeDefault | The default mode, a binarized alpha cutoff of 1.
ShapeModeBinarizeAlpha | A binarized alpha cutoff with a given integer value.
ShapeModeReverseBinarizeAlpha | A binarized alpha cutoff with a given integer value, but with the opposite comparison.
ShapeModeColorKey | A color key is applied.

Definition at line 85 of file SDL_shape.h.

{
/** \brief The default mode, a binarized alpha cutoff of 1. */
ShapeModeDefault,
/** \brief A binarized alpha cutoff with a given integer value. */
ShapeModeBinarizeAlpha,
/** \brief A binarized alpha cutoff with a given integer value, but with the opposite comparison. */
ShapeModeReverseBinarizeAlpha,
/** \brief A color key is applied. */
ShapeModeColorKey
} WindowShapeMode;
WindowShapeMode
WindowShapeMode
An enum denoting the specific type of contents present in an SDL_WindowShapeParams union.
Definition SDL_shape.h:85
ShapeModeColorKey
@ ShapeModeColorKey
A color key is applied.
Definition SDL_shape.h:93

## Function Documentation

## SDL_CreateShapedWindow()

SDL_Window * SDL_CreateShapedWindow | ( | const char * | title,
|  | unsigned int | x,
|  | unsigned int | y,
|  | unsigned int | w,
|  | unsigned int | h,
|  | Uint32 | flags )

extern

Create a window that can be shaped with the specified position, dimensions, and flags.

Parameters

  title | The title of the window, in UTF-8 encoding.
  x | The x position of the window, SDL_WINDOWPOS_CENTERED, or SDL_WINDOWPOS_UNDEFINED.
  y | The y position of the window, SDL_WINDOWPOS_CENTERED, or SDL_WINDOWPOS_UNDEFINED.
  w | The width of the window.
  h | The height of the window.
  flags | The flags for the window, a mask of SDL_WINDOW_BORDERLESS with any of the following: SDL_WINDOW_OPENGL, SDL_WINDOW_INPUT_GRABBED, SDL_WINDOW_HIDDEN, SDL_WINDOW_RESIZABLE, SDL_WINDOW_MAXIMIZED, SDL_WINDOW_MINIMIZED, SDL_WINDOW_BORDERLESS is always set, and SDL_WINDOW_FULLSCREEN is always unset.

Returns
  the window created, or NULL if window creation failed.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_DestroyWindow

## SDL_GetShapedWindowMode()

int SDL_GetShapedWindowMode | ( | SDL_Window * | window,
|  | SDL_WindowShapeMode * | shape_mode )

extern

Get the shape parameters of a shaped window.

Parameters

  window | The shaped window whose parameters should be retrieved.
  shape_mode | An empty shape-mode structure to fill, or NULL to check whether the window has a shape.

Returns
  0 if the window has a shape and, provided shape_mode was not NULL, shape_mode has been filled with the mode data, SDL_NONSHAPEABLE_WINDOW if the SDL_Window given is not a shaped window, or SDL_WINDOW_LACKS_SHAPE if the SDL_Window given is a shapeable window currently lacking a shape.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_WindowShapeMode
  SDL_SetWindowShape

## SDL_IsShapedWindow()

SDL_bool SDL_IsShapedWindow | ( | const SDL_Window * | window | ) |

extern

Return whether the given window is a shaped window.

Parameters

  window | The window to query for being shaped.

Returns
  SDL_TRUE if the window is a window that can be shaped, SDL_FALSE if the window is unshaped or NULL.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_CreateShapedWindow

## SDL_SetWindowShape()

int SDL_SetWindowShape | ( | SDL_Window * | window,
|  | SDL_Surface * | shape,
|  | SDL_WindowShapeMode * | shape_mode )

extern

Set the shape and parameters of a shaped window.

Parameters

  window | The shaped window whose parameters should be set.
  shape | A surface encoding the desired shape for the window.
  shape_mode | The parameters to set for the shaped window.

Returns
  0 on success, SDL_INVALID_SHAPE_ARGUMENT on an invalid shape argument, or SDL_NONSHAPEABLE_WINDOW if the SDL_Window given does not reference a valid shaped window.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_WindowShapeMode
  SDL_GetShapedWindowMode